// p0-p5 - , b0-b5 - 
var fill = new Array ('','','','','','');
 //   

var pp0=-1; pp0s='';

function showFill () {
 var s='',k=0;
 for (var i=0; i<6; i++) {
  if (fill[i]!='') { s+=fill[i]; k++; }
  else { s+='-'; }
  if (i==2) s+='<br>';
  else if (i<5) s+=' ';
 }
 document.getElementById('help').innerHTML=s;
 document.f1.select.value=s;
 if (k==6) { 
  document.f1.submit.disabled=false;
 }
 else {
  document.f1.submit.disabled=true;
 }
}

function DragObject (element) {
 element.dragObject = this;
 dragMaster.makeDraggable(element);
 var rememberPosition;
 var mouseOffset;
 this.onDragStart = function(offset) {
  var s = element.style;
  rememberPosition = {top: s.top, left: s.left, position: s.position};
  s.position = 'absolute';
  mouseOffset = offset;
  var pp=element.id.substring(1); //. ,   
  for (var i=0; i<6; i++) if (fill[i].substring(1)==pp) {
   fill[i]=''; pp0=i; pp0s='b'+pp;
  }
  showFill ();
 }
 this.hide = function() {
  element.style.display = 'none' ;
 }
 this.show = function() {
  element.style.display = '';
 }
 this.onDragMove = function(x, y) {
  element.style.top =  y - mouseOffset.y +'px';
  element.style.left = x - mouseOffset.x +'px';
 }
 this.onDragSuccess = function(dropTarget) { 
  //alert (dropTarget+' '+this.toString()); //ex.: e4, wr8
  var pp=parseInt(dropTarget.toString().substring(1));
  fill[pp]=this.toString();
  showFill ();
 }
 this.onDragFail = function() {
  var s = element.style;
  s.top = rememberPosition.top;
  s.left = rememberPosition.left;
  s.position = rememberPosition.position;
  if (pp0>-1) fill[pp0]=pp0s;
  showFill ();
 }
 this.toString = function() {
  return element.id;
 }
}

function DropTarget (element) {
 element.dropTarget = this;
 this.canAccept = function(dragObject) {  //  ?
 // dragObject - 
 // this.toString() - 
  if (this.toString()=='dropObjects') return true;
 //     dragObjects,     -      
  var pp=parseInt(this.toString().substring(1));
  showFill ();
  if (fill[pp]!='') { return false; }
  return true;
 }
 this.accept = function(dragObject) {
  this.onLeave();
  //dragObject.hide();
  //alert(" '"+this+"':   '"+dragObject+"'"); //ex.: this=a1, dragObject=bq8
  var fields = document.getElementById('pTable').getElementsByTagName('img');
  var dragName = dragObject.toString();
  for (var i=0; i<fields.length; i++) {
   if (fields[i].alt == dragName) { fields[i].alt=''; break; }
  }
  document.getElementById(this).setAttribute('alt',dragName);
 }
 this.onLeave = function() { element.className =  ''; }
 this.onEnter = function() { element.className = 'uponMe'; }
 this.toString = function() { return element.id; }
}

var dragMaster = (function() {
 var dragObject;
 var mouseDownAt;
 var currentDropTarget;
 function mouseDown(e) { //   :  
  e = fixEvent(e);
  if (e.which!=1) return;
  mouseDownAt = { x: e.pageX, y: e.pageY, element: this }
  addDocumentEventHandlers();
  return false;
 }
 function mouseMove(e) {
  e = fixEvent(e)
  if (mouseDownAt) { //    
   if (Math.abs(mouseDownAt.x-e.pageX)<5 && Math.abs(mouseDownAt.y-e.pageY)<5) {
    return false;
   }
   //  
   var elem  = mouseDownAt.element; //    
   dragObject = elem.dragObject; // ,      
   var mouseOffset = getMouseOffset(elem, mouseDownAt.x, mouseDownAt.y);
   mouseDownAt = null; //     ,   
   dragObject.onDragStart(mouseOffset); // 
  }
  dragObject.onDragMove(e.pageX, e.pageY);
  var newTarget = getCurrentTarget(e);
  if (currentDropTarget != newTarget) {
   if (currentDropTarget) { currentDropTarget.onLeave(); }
   if (newTarget) { newTarget.onEnter(); }
   currentDropTarget = newTarget;
  }
  return false;
 }
 function mouseUp() { // 
  if (!dragObject) {
   mouseDownAt = null;
  } 
  else {
   if (currentDropTarget) {
    currentDropTarget.accept(dragObject);
    dragObject.onDragSuccess(currentDropTarget);
  } 
  else { dragObject.onDragFail(); }
  dragObject = null;
 }
 removeDocumentEventHandlers();
}

function getMouseOffset(target, x, y) {
 var docPos = getOffset(target);
 return {x:x - docPos.left, y:y - docPos.top};
}
function getCurrentTarget(e) {
 if (navigator.userAgent.match('MSIE') || navigator.userAgent.match('Gecko')) {
  var x=e.clientX, y=e.clientY;
 } 
 else {	var x=e.pageX, y=e.pageY; }
 dragObject.hide();
 var elem = document.elementFromPoint(x,y);
 dragObject.show();
 //    dropTarget
 while (elem) { //    dragObject 
  if (elem.dropTarget && elem.dropTarget.canAccept(dragObject)) {
   return elem.dropTarget;
  }
  elem = elem.parentNode;
 }
 return null; //dropTarget  
}
function addDocumentEventHandlers() { //    
 document.onmousemove = mouseMove;
 document.onmouseup = mouseUp;                                                 
 document.ondragstart = document.body.onselectstart = function() { return false };
}
function removeDocumentEventHandlers() { //  
 document.onmousemove = document.onmouseup = document.ondragstart = document.body.onselectstart = null;
}
return { makeDraggable: function(element) { element.onmousedown = mouseDown; } }
}())

function fixEvent(e) { //   ""  IE
 e = e || window.event;
 //  pageX/pageY  IE
 if ( e.pageX == null && e.clientX != null ) {
  var html = document.documentElement;
  var body = document.body;
  e.pageX = e.clientX + (html && html.scrollLeft || body && body.scrollLeft || 0) - (html.clientLeft || 0);
  e.pageY = e.clientY + (html && html.scrollTop || body && body.scrollTop || 0) - (html.clientTop || 0);
 }
 //  which  IE
 if (!e.which && e.button) {
  e.which = e.button & 1 ? 1 : ( e.button & 2 ? 3 : ( e.button & 4 ? 2 : 0 ) );
 }
 return e;
}

function getOffset(elem) {
 if (elem.getBoundingClientRect) { return getOffsetRect(elem); } 
 else { return getOffsetSum(elem); }
}

function getOffsetRect(elem) {
 var box = elem.getBoundingClientRect();
 var body = document.body;
 var docElem = document.documentElement;
 var scrollTop = window.pageYOffset || docElem.scrollTop || body.scrollTop;
 var scrollLeft = window.pageXOffset || docElem.scrollLeft || body.scrollLeft;
 var clientTop = docElem.clientTop || body.clientTop || 0;
 var clientLeft = docElem.clientLeft || body.clientLeft || 0;
 var top  = box.top +  scrollTop - clientTop;
 var left = box.left + scrollLeft - clientLeft;
 return { top: Math.round(top), left: Math.round(left) };
}

function getOffsetSum(elem) {
 var top=0, left=0
 while(elem) {
  top = top + parseInt(elem.offsetTop);
  left = left + parseInt(elem.offsetLeft);
  elem = elem.offsetParent;
 }
 return {top: top, left: left};
}